import Qt 4.7

Item {
    id: xaqlmlAddressBookPicker
    width: 250
    height: 364

    property bool enabled: true

    signal entrySelected()

    //
    // on/off switch
    //
    /*
    Item {
        id: onOffBox
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top

        function setOn() {
            console.debug("set on")
            onOffSliderRect.anchors.leftMargin = 35
            onOffRect.gradient = selectedEnabledGradient
        }

        function setOff() {
            console.debug("set off")
            onOffSliderRect.anchors.leftMargin = 0
            onOffRect.gradient = selectedDisabledGradient
        }

        function loadSettings() {
            if (xaqmlDatePicker1.enabled) setOn()
            else setOff()
        }

        Gradient {
            id: selectedEnabledGradient
            GradientStop { position: 0.0; color: "#2356b8" }
            GradientStop { position: 0.8; color: "#6396f8" }
            GradientStop { position: 1.0; color: "#6396f8" }
        }
        Gradient {
            id: selectedDisabledGradient
            GradientStop { position: 0.0; color: "#717171" }
            GradientStop { position: 0.8; color: "white" }
            GradientStop { position: 1.0; color: "white" }
        }

        Text {
            id: onOffBoxLabel
            anchors.left: parent.left
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 120
            height: 18
            color: "#ffffff"
            text: "Enabled:"
            font.bold: true
            horizontalAlignment: Text.AlignRight
            verticalAlignment: Text.AlignVCenter
            smooth: true
        }

        Rectangle {
            id: onOffRect
            anchors.left: parent.left
            anchors.leftMargin: 130
            anchors.top: parent.top
            anchors.topMargin: 5
            width: 65
            height: 20
            //color: "blue"
            gradient: selectedEnabledGradient
            smooth: true
            radius: 3

            Text {
                id: onLabel
                anchors.left: parent.left
                anchors.top: parent.top
                anchors.right: parent.right
                anchors.rightMargin: 32
                height: 20
                color: "white"
                text: "ON"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true

                MouseArea {
                    id: onMouseArea
                    anchors.fill: parent

                    onClicked: {
                        onOffBox.setOff()
                        xaqmlDatePicker1.enabled = false
                        dateSelected()
                    }
                }
            }
            Text {
                id: offLabel
                anchors.left: parent.left
                anchors.leftMargin: 32
                anchors.top: parent.top
                anchors.right: parent.right
                height: 20
                color: "black"
                text: "OFF"
                font.bold: true
                horizontalAlignment: Text.AlignHCenter
                verticalAlignment: Text.AlignVCenter
                smooth: true

                MouseArea {
                    id: offMouseArea
                    anchors.fill: parent

                    onClicked: {
                        onOffBox.setOn()
                        xaqmlDatePicker1.enabled = true
                        dateSelected()
                    }
                }
            }

            Rectangle {
                id: onOffSliderRect
                anchors.left: parent.left
                anchors.top: parent.top
                width: 30
                height: 20
                color: "white"
                border.color: "#222222"
                border.width: 1
                smooth: true
                radius: 3

                Behavior on anchors.leftMargin { PropertyAnimation {duration:  50} }
            }
        }

        Component.onCompleted: loadSettings()
    }
*/
    //
    // selection list
    //
    /*
    Rectangle {
        id: attachmentBrowserRect
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        anchors.topMargin: 40
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 20
        clip: true
        color: "black"

        Component {
            id: attachmentBrowserDelegate

            Item {
                id: attachmentBrowserDelegateItem
                width: attachmentGrid.cellWidth; height: attachmentGrid.cellHeight

                MouseArea {
                    anchors.fill: parent
                    onClicked: {
                        attachmentGrid.currentIndex = index
                        //if (url == "" || url.substr(0,7) == "http://" || url.substr(0,8) == "https://") attachmentBrowser.urlString = url;
                        //else attachmentBrowser.urlString = "about:blank";
                    }
                    onDoubleClicked: {
                        console.debug("Item Double Clicked -> Starting external viewer")
                        console.debug(url)
                        console.debug(name)
                        console.debug(iconpath)
                        console.debug(uid)

                        //QtHandler.openExternalViewerForAttachment(uid)
                    }
                }

                states: [
                    State {
                        name: "selected"
                        when: attachmentBrowserDelegateItem.GridView.isCurrentItem
                        PropertyChanges {
                            //target: attachmentBrowserRect;
                            //color: "black";
                        }
                        PropertyChanges {
                            //target: attachmentBrowser
                            //urlString : (url == "" || url.substr(0,7) == "http://" || url.substr(0,8) == "https://") ? url : "about:blank"
                        }
                    }
                ]

                Column {
                    id: attachmentBrowserDelegateColumn
                    anchors.top: parent.top
                    anchors.topMargin: 2
                    anchors.bottomMargin: 2
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    anchors.right: parent.right
                    anchors.rightMargin: 1
                    //Image {
                    //    source: iconpath;
                    //    anchors.top: parent.top
                    //    anchors.topMargin: 2
                    //    anchors.right: parent.right;
                    //    anchors.rightMargin: 4.0;
                    //    smooth: true
                    //
                    Text {
                        text: subject;
                        font.family: "Arial";
                        font.bold: true;
                        font.pointSize: 12;
                        anchors.topMargin: 2
                        anchors.left: parent.left;
                        anchors.leftMargin: 4.0;
                        color: "white";
                        smooth: true;
                    }
                    Text {
                        text: isSelected;
                        anchors.topMargin: 2
                        anchors.right: parent.right;
                        anchors.rightMargin: 4.0;
                        smooth: true
                        color: "white";
                    }
                }
            }
        }

        GridView {
            id: attachmentGrid
            anchors.fill: parent
            anchors.topMargin: 1
            anchors.leftMargin: 2
            anchors.rightMargin: 2
            //transformOrigin: Item.Top

            cellWidth: parent.width-4; cellHeight: 40

            //model: testmodel
            model: contextModel
            delegate: attachmentBrowserDelegate
            //highlight: Rectangle { color: "lightsteelblue"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
            highlight: Rectangle { color: "#3e3c3c"; radius: 5; smooth: true; border.color: "white"; border.width: 1}
            focus: true

            onModelChanged: {
                console.debug("<< New Model set for Context Grid")
                if (attachmentGrid.count == 0) {
                    //attachmentBrowser.urlString = "about:blank"
                    //attachmentBrowserRect.color = "darkgray"
                }
            }
        }
    }
*/

    Rectangle {
        id: attachmentBrowserRect
        anchors.left: parent.left
        anchors.leftMargin: 4
        anchors.right: parent.right
        anchors.rightMargin: 4
        anchors.top: parent.top
        anchors.topMargin: 4
        anchors.bottom: parent.bottom
        anchors.bottomMargin: 4
        clip: true
        color: "#222222"

        ListView  {
            id :  treeView
            anchors.top: parent.top
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottom: parent.bottom

            //model: visualTree
            model: contextModel
            delegate: treeDelegate

            onFocusChanged: {
                console.debug("treeView got Focus")
            }

            onModelChanged: {
                console.debug("<< onModelChanged:New Model set for Context treeView")
                if (treeView.count == 0) {
                    //attachmentBrowser.urlString = "about:blank"
                    //attachmentBrowserRect.color = "darkgray"
                }
            }
        }

        //VisualDataModel {
        //    id: visualTree
        //    delegate:  treeDelegate
        //    model: contextModel

        // Component  delegate
        Component  {
            id:  treeDelegate
            Item  {
                id :  wrapper
                height :  22
                width :  treeView.width

                Rectangle  {
                    id:  levelMarginElement
                    // Starting  with  six  levels  of nesting  does not  shift the  descendants
                    // So  how  else  can  get a  very  wide  window
                    width :  (level> 5? 6: level) * 14  +  5
                    anchors.left: parent.left
                }

                // Field  for  the opening / closing  descendants.
                // In  leaves  no  visible
                Item  {
                    id:  nodeOpenElement
                    anchors.left:  levelMarginElement.right
                    anchors.verticalCenter:  wrapper.verticalCenter
                    height:  20
                    state:  "leafnode"
                    Image  {
                        id:  triangleOpenImage
                        //fillMode: Image.PreserveAspectFit
                        height: 16
                        width: 16
                        anchors.top: parent.top
                        anchors.topMargin: 2

                        source :  isSelectedImagePath

                        // Catches  clicking  the mouse  and  open / close  element
                        MouseArea  {
                            anchors.fill:  parent
                            onClicked:  {
                                if (hasChildren) {
                                    //(isOpened)  ? contextModel.closeItem (index) : contextModel.openItem (index)

                                    // sub-view navigation (iPhone style)
                                    //treeView.model.rootIndex = treeView.model.modelIndex(index)
                                }
                                contextModel.switchSelectionOnItem(index)

                                console.debug("Item Clicked -> ")
                                console.debug(subject)
                                console.debug(isSelected)
                            }
                        }
                    }
                    states :  [
                        State  {
                            name: "leafnode"
                            when: isSelected
                            PropertyChanges  {
                                target:  nodeOpenElement;
                                visible:  true;
                                width:  22;
                            }
                            PropertyChanges  {
                                target :  triangleOpenImage
                                //source :  "qrc:icons/73-radar.png"
                                //source :  "qrc:icons2/checkbox-selected.png"

                            }
                        },
                        State  {
                            name: "leafnode"
                            when: !isSelected
                            PropertyChanges  {
                                target:  nodeOpenElement;
                                visible:  true;
                                width:  22;
                            }
                            PropertyChanges  {
                                target :  triangleOpenImage
                                //source :  "qrc:icons2/checkbox-deselected.png"
                            }
                        }

                        /*
                            // Leaf
                            // Field  is not  visible
                            State  {
                                name: "leafnode"
                                when: !hasChildren
                                PropertyChanges  {
                                    target:  nodeOpenElement;
                                    //visible:  false;
                                    //width:  0;
                                    visible:  true;
                                    width:  16;
                                }
                                PropertyChanges  {
                                    target :  triangleOpenImage
                                    source :  "qrc:icons/73-radar.png"
                                }
                            },
                            // Clear  element
                            // Field  is visible  and  displays the  corresponding  icon
                            State  {
                                name:  "openedNode"
                                when:  (hasChildren) && (isOpened)
                                PropertyChanges  {
                                    target:  nodeOpenElement;
                                    visible:  true;
                                    width:  16;
                                }
                                PropertyChanges  {
                                    target :  triangleOpenImage
                                    source :  "qrc:icons/73-radar.png"
                                }
                            },
                            // Private  element
                            // Field  is visible  and  displays the  corresponding  icon
                            State  {
                                name:  "closedNode"
                                when:  (hasChildren) && (!isOpened)
                                PropertyChanges  {
                                    target:  nodeOpenElement
                                    visible:  true
                                    width:  16
                                }
                                PropertyChanges  {
                                    target:  triangleOpenImage
                                    source:  "qrc:icons/73-radar.png"
                                }
                            }
                            */
                    ]
                }

                // Field  for  displaying  data  element
                Text  {
                    id:  nameTextElement
                    text:  subject

                    anchors.left:  nodeOpenElement.right
                    anchors.leftMargin: 5
                    anchors.top:  parent.top
                    anchors.topMargin: 4
                    anchors.bottom:  parent.bottom
                    anchors.right:  parent.right
                    color: "white"

                    //font.family: "Arial";
                    font.bold: false;
                    font.pointSize: 12;
                    smooth: true;
                }

                Rectangle  {
                    height:  1
                    //anchors.top:  parent.top
                    anchors.bottom: parent.bottom
                    anchors.left:  parent.left
                    anchors.right:  parent.right
                    color:  "#303030"
                }
            }

        }
        // }
    }


}
