import QtQuick 1.0

Item {
    id: container
    property int level: 0
    property int selected: 0
    signal clicked()

    //width: 25; height: 25
    width: 21; height: 24

    Rectangle {
        id: rectangle
        border.color: (container.selected == 1) ? "darkgray" : "transparent"
        //border.color: "transparent"
        color: (container.selected == 1) ? "black" : "transparent"
        anchors.fill: parent
        radius: 2
        smooth: true

        Image {
            id: image
            y:2
            source: "qrc:icons2/actionBarIconLockL" + container.level + "_21px.png";
        }
    }

    MouseArea {
        anchors.fill: parent
        onClicked: container.clicked()
    }
}


